Generator::send
Generator::valid
Generator
PHP Manual

# Generator::throw

Throw an exception into the generator

### Description

public mixed Generator::throw ( Exception `$exception` )

Throws an exception into the generator and resumes execution of the generator. The behavior will be the same as if the current yield expression was replaced with a throw $exception statement.

If the generator is already closed when this method is invoked, the exception will be thrown in the caller's context instead.

### Parameters

`exception`

  Exception to throw into the generator.

### Examples

Example #1 Throwing an exception into a generator

`<?php
function gen() {
echo "Foo\n";
try {
yield;
} catch (Exception $e) {
echo "Exception: {$e->getMessage()}\n";
}
echo "Bar\n";
}
$gen = gen();
$gen->rewind();
$gen->throw(new Exception('Test'));
?>`

The above example will output:

    Foo
    Exception: Test
    Bar

### Return Values

Returns the yielded value.